
/*
*===========================================================
*        File Name: channel.h
*          Version: A1
*          Created: 2015-8-14
*         Revision: 00
*         Compiler: ARMCC.exe V5.03.0.76
*           Author: 
*          Company: Analog Devices Inc
*===========================================================
*/
#ifndef CHANNEL_H_
#define CHANNEL_H_

#include "inc\ADuCM360.h"
#include "inc\system_ADUCM360.h"
#include "i2c.h"
#include "adc.h"
#include "adp5065.h"
#include "adg715.h"
#include "battery.h"
#include "channel.h"                  
//typedef enum {
//	SW_LED_COLOR_GREY		= 0,
//	SW_LED_COLOR_GREEN	= 1,
//	SW_LED_COLOR_ORANGE	= 2,
//	SW_LED_COLOR_YELLOW	= 3,
//	SW_LED_COLOR_READ		= 4
//} SW_LED_COLOR;
//typedef enum {
//	SW_LED_OFF = 0,
//	SW_LED_ON	 = 1
//} SW_LED_STATUS;
//typedef struct {
//	unsigned char StrIndex : 4;
//	SW_LED_COLOR	color : 3;
//	SW_LED_STATUS status : 1;
//} CHG_MONITOR_STATUS_S_T;
//typedef union {
//	CHG_MONITOR_STATUS_S_T REG;
//	unsigned char Val;
//}CHG_MONITOR_STATUS_U_T;
//typedef struct {
//	CHG_MONITOR_STATUS_U_T Vin;
//	CHG_MONITOR_STATUS_U_T Iin;
//	CHG_MONITOR_STATUS_U_T Tdie;
//	CHG_MONITOR_STATUS_U_T Absent;
//	CHG_MONITOR_STATUS_U_T Short;
//	CHG_MONITOR_STATUS_U_T Tbat;
//} CHG_MONITOR_STATUS_T1;
#define ALLOWED_FAULT_NUMBER 3
typedef struct {
//Charger Status
	unsigned short VIN_OV  : 1;		//Input Voltage Over-voltage Status: ADP5065 Charger Status 1 Bit 7
	unsigned short VIN_OK  : 1;		//Input Voltage Under-voltage Status: ADP5065 Charger Status 1 Bit 6
	unsigned short IIN_LIM : 1;		//Input Current Limitation Status: ADP5065 Charger Status 1 Bit 5
	unsigned short TSD_LIM : 1;		//Die temperature falut: ADP5065 Charger Status 1 Bit 4
	unsigned short TSD_130 : 1;		//Die temperature falut: ADP5065 Fault Register Bit 1
	unsigned short TSD_140 : 1;		//Die temperature falut: ADP5065 Fault Register Bit 0
	unsigned short IPK_STAT : 1;	//Inductor peak current-limit fault: ADP5065 Charger Status Register 2 Bit 4 IPK_STAT 
	unsigned short reserved : 1;	//Reserved.
//Battery Status	
	unsigned short BAT_SHR : 1;		//Battery Shorting Register: ADP5065 Fault Register Bit 3 BAT_SHR
	unsigned short BAT_STA : 3;		//Battery Voltage Status, ADP5065: BATTERY_STATUS[2:0] 
	unsigned short BAT_OTS : 1;		//Battery Over Temperature Status, Need SW Judge.
	unsigned short BAT_TSR : 3;		//Battery Tempreature Status Register, ADP5065 THR_STATUS[2:0] 
}CHG_MONITOR_STATUS_S_T;
typedef struct {
//Charger Status
	unsigned short VIN_STA : 2;		//Input Voltage Status. "00": OK; "01": Too High; "10": Too Low; "11": Reserved.
	unsigned short IIN_LIM : 1;		//Input Current Limitation Status: ADP5065 Charger Status 1 Bit 5
	unsigned short TSD_STA : 2;		//Die Temperature Status. "00": OK; "01": >115 degC; "10": >130 degC; "11": >140 degC.
	unsigned short IPK_STA : 1;		//Inductor peak current-limit fault: ADP5065 Charger Status Register 2 Bit 4 IPK_STAT 
	unsigned short Reserv1 : 2;		//Reserved.
//Battery Status
	unsigned short BAT_SHR  : 1;	//Battery Shorting Register: ADP5065 Fault Register Bit 3 BAT_SHR
	unsigned short BAT_VSTA : 3;	//Battery Voltage Status, ADP5065: BATTERY_STATUS[2:0]
	unsigned short BAT_TSTA : 3;	//Battery Tempreature Status Register, ADP5065 THR_STATUS[2:0] 
	unsigned short Reserv2  : 1;	//Reserved.
}CHG_MONITOR_STATUS_ADJ_S_T;
typedef union {
	CHG_MONITOR_STATUS_ADJ_S_T REG;
	unsigned short Val;
}CHG_MONITOR_STATUS_U_T;


typedef enum  {														//CHANNEL_STATUS_T
	CHG_IDLE = 0 , 
	CHG_TRICKLE = 1 , 
	CHG_CC = 2 , 
	CHG_CV = 3 , 
	CHG_Complete = 4 ,
	CHG_SUSPEND = 5,
	CHG_TIMER_EXPIRED = 6,
	CHG_BATTERY_DETECTION = 7,
	DCHG_S1 = 8 , 
	DCHG_S2 = 9 , 
	DCHG_S3 = 10 , 
	TEST_COMPLETE = 11
}CHANNEL_STATUS_T;
typedef unsigned char CHANNEL_ACTIVE_T;			//CHANNEL_ACTIVE_T
typedef enum {					//CHARGE_INCURRLIMIT_T
	I100mA = 0, 
	I150mA = 1, 
	I200mA = 2, 
	I300mA = 3, 
	I400mA = 4, 
	I500mA = 5, 
	I600mA = 6, 
	I700mA = 7, 
	I800mA = 8, 
	I900mA = 9,
	I1000mA = 10,
	I1100mA = 11,
	I1200mA = 12,
	I1300mA = 13,
	I1400mA = 14,
	I1500mA = 15
} CHARGE_INCURRLIMIT_T;
typedef enum {					//CHARGE_TRIC_VTH_T
	V2P4V = 0, 
	V2P5V = 1, 
	V2P6V = 2, 
	V3P3V = 3 
} CHARGE_TRIC_VTH_T;
typedef enum {					//CHARGE_TRIC_CURR_T
	 I5mA = 0, 
	I10mA = 1, 
	I20mA = 2
} CHARGE_TRIC_CURR_T;
typedef enum {					//CHARGE_FAST_CURR_T
	 I550mA = 0, 
	 I650mA = 1, 
	 I750mA = 2,
	 I850mA = 3,
	 I950mA = 4,
	I1050mA = 5,
	I1150mA = 6,
	I1250mA = 7
} CHARGE_FAST_CURR_T;
typedef enum {					//CHARGE_TERM_VOLT_T
	V3P50V = 0,                                                                                                               
	V3P52V = 1, 
	V3P54V = 2, 
	V3P56V = 3, 
	V3P58V = 4, 
	V3P60V = 5, 
	V3P62V = 6, 
	V3P64V = 7, 
	V3P66V = 8, 
	V3P68V = 9, 
	V3P70V = 10,
	V3P72V = 11,
	V3P74V = 12,
	V3P76V = 13,
	V3P78V = 14,
	V3P80V = 15,
	V3P82V = 16,
	V3P84V = 17,
	V3P86V = 18,
	V3P88V = 19,
	V3P90V = 20,
	V3P92V = 21,
	V3P94V = 22,
	V3P96V = 23,
	V3P98V = 24,
	V4P00V = 25,
	V4P02V = 26,
	V4P04V = 27,
	V4P06V = 28,
	V4P08V = 29,
	V4P10V = 30,
	V4P12V = 31,
	V4P14V = 32,
	V4P16V = 33,
	V4P18V = 34,
	V4P20V = 35,
	V4P22V = 36,
	V4P24V = 37,
	V4P26V = 38,
	V4P28V = 39,
	V4P30V = 40,
	V4P32V = 41,
	V4P34V = 42,
	V4P36V = 43,
	V4P38V = 44,
	V4P40V = 45,
	V4P42V = 46
} CHARGE_TERM_VOLT_T;
typedef enum {					//CHARGE_TERM_CURR_T
	I32P5mA = 0, 
	I52P5mA = 1, 
	I72P5mA = 2, 
	I92P5mA = 3
} CHARGE_TERM_CURR_T;
typedef enum {					//DISCHARGE_TERM_VOLT_T
	DV2P0 = 22, 
	DV2P1 = 21, 
	DV2P2 = 20, 
	DV2P3 = 19,
	DV2P4 = 18, 
	DV2P5 = 17, 
	DV2P6 = 16, 
	DV2P7 = 15,
	DV2P8 = 14, 
	DV2P9 = 13, 
	DV3P0 = 12, 
	DV3P1 = 11,	
	DV3P2 = 10,	
	DV3P3 = 9,	
	DV3P4 = 8,	
	DV3P5 = 7,	
	DV3P6 = 6,	
	DV3P7 = 5,	
	DV3P8 = 4,	
	DV3P9 = 3,	
	DV4P0 = 2,	
	DV4P1 = 1,	
	DV4P2 = 0
} DISCHARGE_TERM_VOLT_T;

typedef enum {					//DISCHARGE_TERM_CURR_T
	  DI00mA = 0, 
	  DI50mA = 1, 
	 DI100mA = 2, 
	 DI150mA = 3,
	 DI200mA = 4, 
	 DI250mA = 5, 
	 DI300mA = 6, 
	 DI350mA = 7,
	 DI400mA = 8, 
	 DI450mA = 9, 
	 DI500mA = 10, 
	 DI550mA = 11,	
	 DI600mA = 12,	
	 DI650mA = 13,	
	 DI700mA = 14,	
	 DI750mA = 15,	
	 DI800mA = 16,	
	 DI850mA = 17,	
	 DI900mA = 18,	
	 DI950mA = 19,	
	DI1000mA = 20
} DISCHARGE_TERM_CURR_T;
typedef	struct {					//CHANNEL_CFG_T
		CHARGE_INCURRLIMIT_T InCurrIimt;
		CHARGE_TRIC_VTH_T ChargeTricVth;
		CHARGE_TRIC_CURR_T ChargeTricCurr;
		CHARGE_FAST_CURR_T ChargeFastCurr;
		CHARGE_TERM_VOLT_T ChargeTermVolt;
		CHARGE_TERM_CURR_T ChargeTermCurr;
		DISCHARGE_TERM_VOLT_T DischargeTermVolt[3];
		DISCHARGE_TERM_CURR_T DischargeTermCurr[3];
	}CHANNEL_CFG_T;
typedef struct {					//CHANNEL_T
	const unsigned char ch_no;
	unsigned short count;
	CHANNEL_ACTIVE_T active;
	unsigned char test_start;
	CHANNEL_STATUS_T status;
	CHG_MONITOR_STATUS_U_T mstatus;
	unsigned char fault_count;
	unsigned short test_cycle_cnt;
	CHANNEL_CFG_T cfg;
	BATTERY_T bat;
	ADP5065_SFR_T adp5065w;
	unsigned char fw_adg5065[sizeof(ADP5065_SFR_T)/8+1];		//Flag to indicate the register need to write into ADP565. Cleared after writing.
	ADP5065_SFR_T adp5065r;
	unsigned char adp5065r_fupd;	//Flat to indicate that all the adp5065r data has just be updated by TASK and never read out by monitor program. 
	ADG715_SFR_T  adg715w;
	ADG715_SFR_T  adg715r;
}CHANNEL_T;

#endif	/*CHANNEL_H_*/

