/*
*===========================================================
*        File Name: monitor.c
*          Version: A1
*          Created: 2015-8-14
*         Revision: 00
*         Compiler: ARMCC.exe V5.03.0.76
*           Author: 
*          Company: Analog Devices Inc
*===========================================================
*/
#include "monitor.h"
#include "cn0352.h"


static unsigned char monitor_charge(ADP5065_SFR_T* ptr);
static unsigned char monitor_discharge(void);

MONITOR_T monitor = {
	.charging = monitor_charge,
	.discharging = monitor_discharge
};
static unsigned char monitor_charge(ADP5065_SFR_T* ptr){
	unsigned char status = 0;
		if(
			(ptr->reg.ChargerSta1.BITs.VIN_OV == 1)||
			(ptr->reg.ChargerSta1.BITs.VIN_ILIM == 1)||
			(ptr->reg.ChargerSta1.BITs.THERM_LIM == 1)||
			(ptr->reg.ChargerSta1.BITs.CHARGER_STATUS == CHARGER_STATUS_SUSPEND)||
			
			//(ptr->reg.ChargerSta2.BITs.BATTERY_STATUS)??||
			(ptr->reg.ChargerSta2.BITs.IPK_STAT == 1)||
			//(ptr->reg.ChargerSta2.BITs.BATTERY_STATUS == ??)||
			(ptr->reg.FaultReg.Val != 0x00)			//Fault happened.
			){
			status = 1;		//Charging Issue Happened.	
		}
		else{
			status = 0;		//Charging Status OK.
		}
	return(status);
};
static unsigned char monitor_discharge(void){
	return(1);
};

